#!/bin/sh

#
# hacked by <hvr@gnu.org>
#

testcase() {
    TEXT="$1"
    ALGO="$2"
    CKSUM="$3"

    echo -n "checking $ALGO..."

    if echo "$TEXT" | ./hashalot $ALGO 2> /dev/null | cksum | ( 
	read _CKSUM _SIZE
	
	if [ "$_SIZE" != "32" ]; then
	    echo "unexpected size ($_SIZE)"
	    return 0 # fail
	fi
    
	if [ "$_CKSUM" != "$CKSUM" ]; then
	    echo "cksum didn't match ($CKSUM != $_CKSUM)"
	    return 0 # fail
	fi

	return 1 # OK
    ); then
	echo "FAILED"
	return 1
    fi
    echo "OK"
    return 0
}

echo "checks..."

if ! testcase ""    sha256 3241420129    ; then exit 1; fi
if ! testcase "123" sha256 3903349750    ; then exit 1; fi

if ! testcase ""    sha384 2716520957    ; then exit 1; fi
if ! testcase "123" sha384 2407383347    ; then exit 1; fi

if ! testcase ""    sha512 2306787360    ; then exit 1; fi
if ! testcase "123" sha512 4237495555    ; then exit 1; fi

if ! testcase ""    rmd160 2926540639    ; then exit 1; fi
if ! testcase "123" rmd160 3110931825    ; then exit 1; fi

if ! testcase ""    ripemd160 2926540639 ; then exit 1; fi
if ! testcase "123" ripemd160 3110931825 ; then exit 1; fi

#echo "123" | ./hashalot sha512 | read CRC SIZE

exit 0